type token =
  | SEMI
  | LPAREN
  | RPAREN
  | LBRACE
  | RBRACE
  | COMMA
  | LBRACKET
  | RBRACKET
  | LIST
  | PLUS
  | MINUS
  | TIMES
  | DIVIDE
  | ASSIGN
  | CASTBOOL
  | EQ
  | NEQ
  | LT
  | LEQ
  | GT
  | GEQ
  | AND
  | OR
  | MOD
  | RETURN
  | IF
  | ELSE
  | FOR
  | WHILE
  | FUNC
  | IN
  | CLASS
  | NEW
  | ACCESS
  | OPTIONAL
  | INSTANCE
  | HTTP
  | PARAM
  | NAMESPACE
  | ID of (string)
  | TYPE of (string)
  | STRING_LIT of (string)
  | INT_VAL of (int)
  | FLOAT_LIT of (float)
  | BOOL_LIT of (bool)
  | NULL
  | EOF

val program :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Ast.program
